Index: include/scol_plugin_win.h
===================================================================
--- include/scol_plugin_win.h	(revision 2578)
+++ include/scol_plugin_win.h	(revision 2579)
@@ -1,5 +1,5 @@
-/*! \file scol.h
-*	\brief Scol plugin definition API
+/*! \file scol_plugin_win.h
+*	\brief Scol plugin definition API (MS Windows)
 *   \author Sylvain HUET
 */
 
Index: include/scol_plugin_lin.h
===================================================================
--- include/scol_plugin_lin.h	(revision 2578)
+++ include/scol_plugin_lin.h	(revision 2579)
@@ -1,3 +1,7 @@
+/*! \file scol_plugin_linux.h
+*	\brief Scol plugin definition API (GNU / Linux)
+*   \author Sylvain HUET
+*/
 /*
         SCOLPLUGIN.H . 1996-99 . Sylvain HUET
 
Index: include/macros.h
===================================================================
--- include/macros.h	(revision 2578)
+++ include/macros.h	(revision 2579)
@@ -1,3 +1,7 @@
+/*! \file macros.h
+*	\brief usefull Scol macros
+*   \author Sylvain HUET, Stephane Bisaro
+*/
 /*
 This source file is part of Scol
 For the latest info, see http://www.scolring.org
Index: include/scol_glib_keyfile.h
===================================================================
--- include/scol_glib_keyfile.h	(nonexistent)
+++ include/scol_glib_keyfile.h	(revision 2579)
@@ -0,0 +1,49 @@
+/*! \file scol_glib_keyfile.h
+*	\brief header keyfile functions
+*   \author Stephane Bisaro
+*/
+
+/*
+This source file is part of Scol
+For the latest info, see http://www.scolring.org
+
+Copyright (c) 2010 Stephane Bisaro, aka Iri <iri@irizone.net>
+
+This program is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the Free Software
+Foundation; either version 2 of the License, or (at your option) any later
+version.
+
+This program is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public License along with
+this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+Place - Suite 330, Boston, MA 02111-1307, USA, or go to
+http://www.gnu.org/copyleft/lesser.txt
+
+For others informations, please contact us from http://www.scolring.org/
+*/
+
+#ifndef __SCOL_GLIB_INI_H__
+#define __SCOL_GLIB_INI_H__
+
+#include "main.h"
+#include <glib/gstdio.h>
+
+/* comment if  you 'd a 2.26 or + */
+#define GLIB_224
+
+#define GKEYFILE_PKG_NB         31
+#define GKEYFILE_RFL_NB         0
+#define OBJGKEYFILE_HANDLE      0
+
+
+
+int ObjKeyFile;
+/* internals functions */
+int scol_g_key_file_read (GKeyFile *ini, mmachine m);
+
+
+#endif  /* __SCOL_GLIB_INI_H__ */
Index: keyfile.layout
===================================================================
--- keyfile.layout	(nonexistent)
+++ keyfile.layout	(revision 2579)
@@ -0,0 +1,13 @@
+<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
+<CodeBlocks_layout_file>
+	<ActiveTarget name="Release" />
+	<File name="include\macros.h" open="1" top="0" tabpos="4">
+		<Cursor position="2261" topLine="41" />
+	</File>
+	<File name="include\scol_glib_keyfile.h" open="1" top="0" tabpos="3">
+		<Cursor position="1172" topLine="0" />
+	</File>
+	<File name="src\scol_glib_keyfile.c" open="1" top="1" tabpos="2">
+		<Cursor position="2072" topLine="28" />
+	</File>
+</CodeBlocks_layout_file>
Index: pcre.layout
===================================================================
--- pcre.layout	(revision 2578)
+++ pcre.layout	(revision 2579)
@@ -1,10 +1,13 @@
 <?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
 <CodeBlocks_layout_file>
 	<ActiveTarget name="Release" />
-	<File name="include\scol_glib_pregex.h" open="1" top="0" tabpos="1">
-		<Cursor position="1425" topLine="24" />
+	<File name="include\macros.h" open="0" top="0" tabpos="0">
+		<Cursor position="2418" topLine="30" />
 	</File>
-	<File name="src\scol_glib_pregex.c" open="1" top="1" tabpos="2">
-		<Cursor position="2719" topLine="96" />
+	<File name="include\scol_glib_pregex.h" open="1" top="0" tabpos="2">
+		<Cursor position="1422" topLine="61" />
 	</File>
+	<File name="src\scol_glib_pregex.c" open="1" top="1" tabpos="1">
+		<Cursor position="14156" topLine="481" />
+	</File>
 </CodeBlocks_layout_file>
Index: keyfile.depend
===================================================================
--- keyfile.depend	(nonexistent)
+++ keyfile.depend	(revision 2579)
@@ -0,0 +1,942 @@
+# depslib dependency file v1.0
+1299624866 source:x:\utils_g\src\scol_glib_ini.c
+	"../include/scol_glib_ini.h"
+
+1299624866 e/scol_glib_ini.h"
+
+1299625022 x:\utils_g\include\scol_glib_ini.h
+	"main.h"
+	<glib/gstdio.h>
+
+1299710062 io.h>
+
+1298417439 x:\utils_g\include\main.h
+	<stdio.h>
+	<stdlib.h>
+	<string.h>
+	<math.h>
+	<libgen.h>
+	<glib.h>
+	<windows.h>
+	"scol_plugin_win.h"
+	"scol_plugin_lin.h"
+	"macros.h"
+
+1228530722 
+
+1250305080 c:\mingw\include\stdio.h
+	<_mingw.h>
+	<stddef.h>
+	<stdarg.h>
+	<sys/types.h>
+
+1250305082 .h>
+
+1250305074 c:\mingw\include\_mingw.h
+
+1250305082 c:\mingw\include\sys\types.h
+	<_mingw.h>
+	<stddef.h>
+
+1250305080 c:\mingw\include\stdlib.h
+	<_mingw.h>
+	<stddef.h>
+
+1250305080 c:\mingw\include\string.h
+	<_mingw.h>
+	<stddef.h>
+
+1250305078 c:\mingw\include\math.h
+	<_mingw.h>
+
+1250305078 c:\mingw\include\libgen.h
+	<_mingw.h>
+
+1293381426 c:\mingw\include\glib-2.0\glib.h
+	<glib/galloca.h>
+	<glib/garray.h>
+	<glib/gasyncqueue.h>
+	<glib/gatomic.h>
+	<glib/gbacktrace.h>
+	<glib/gbase64.h>
+	<glib/gbitlock.h>
+	<glib/gbookmarkfile.h>
+	<glib/gcache.h>
+	<glib/gchecksum.h>
+	<glib/gcompletion.h>
+	<glib/gconvert.h>
+	<glib/gdataset.h>
+	<glib/gdate.h>
+	<glib/gdatetime.h>
+	<glib/gdir.h>
+	<glib/gerror.h>
+	<glib/gfileutils.h>
+	<glib/ghash.h>
+	<glib/ghook.h>
+	<glib/ghostutils.h>
+	<glib/giochannel.h>
+	<glib/gkeyfile.h>
+	<glib/glist.h>
+	<glib/gmacros.h>
+	<glib/gmain.h>
+	<glib/gmappedfile.h>
+	<glib/gmarkup.h>
+	<glib/gmem.h>
+	<glib/gmessages.h>
+	<glib/gnode.h>
+	<glib/goption.h>
+	<glib/gpattern.h>
+	<glib/gpoll.h>
+	<glib/gprimes.h>
+	<glib/gqsort.h>
+	<glib/gquark.h>
+	<glib/gqueue.h>
+	<glib/grand.h>
+	<glib/grel.h>
+	<glib/gregex.h>
+	<glib/gscanner.h>
+	<glib/gsequence.h>
+	<glib/gshell.h>
+	<glib/gslice.h>
+	<glib/gslist.h>
+	<glib/gspawn.h>
+	<glib/gstrfuncs.h>
+	<glib/gstring.h>
+	<glib/gtestutils.h>
+	<glib/gthread.h>
+	<glib/gthreadpool.h>
+	<glib/gtimer.h>
+	<glib/gtimezone.h>
+	<glib/gtree.h>
+	<glib/gtypes.h>
+	<glib/gunicode.h>
+	<glib/gurifuncs.h>
+	<glib/gutils.h>
+	<glib/gvarianttype.h>
+	<glib/gvariant.h>
+	<glib/gwin32.h>
+
+1293381426 32.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\galloca.h
+	<glib/gtypes.h>
+	<alloca.h>
+	<malloc.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gtypes.h
+	<glibconfig.h>
+	<glib/gmacros.h>
+
+1293381427 ros.h>
+
+1293381426 c:\mingw\lib\glib-2.0\include\glibconfig.h
+	<glib/gmacros.h>
+	<limits.h>
+	<float.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gmacros.h
+	<stddef.h>
+
+1250305078 c:\mingw\include\limits.h
+	<_mingw.h>
+
+1250305076 c:\mingw\include\float.h
+	<_mingw.h>
+
+1250305078 c:\mingw\include\malloc.h
+	<_mingw.h>
+	<stdlib.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\garray.h
+	<glib/gtypes.h>
+
+1293381427 es.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gasyncqueue.h
+	<glib/gthread.h>
+
+1293381427 ead.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gthread.h
+	<glib/gerror.h>
+	<glib/gutils.h>
+	<glib/gatomic.h>
+
+1293381427 mic.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gerror.h
+	<stdarg.h>
+	<glib/gquark.h>
+
+1293381427 rk.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gquark.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gutils.h
+	<glib/gtypes.h>
+	<stdarg.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gatomic.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gbacktrace.h
+	<glib/gtypes.h>
+	<signal.h>
+
+1250305080 c:\mingw\include\signal.h
+	<_mingw.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gbase64.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gbitlock.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gbookmarkfile.h
+	<glib/gerror.h>
+	<time.h>
+
+1250305080 c:\mingw\include\time.h
+	<_mingw.h>
+	<stddef.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gcache.h
+	<glib/glist.h>
+
+1293381427 t.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\glist.h
+	<glib/gmem.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gmem.h
+	<glib/gslice.h>
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gslice.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gchecksum.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gcompletion.h
+	<glib/glist.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gconvert.h
+	<glib/gerror.h>
+
+1293381427 or.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gdataset.h
+	<glib/gquark.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gdate.h
+	<time.h>
+	<glib/gtypes.h>
+	<glib/gquark.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gdatetime.h
+	<glib/gtimezone.h>
+
+1293381427 ezone.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gtimezone.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gdir.h
+	<glib/gerror.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gfileutils.h
+	<glib/gerror.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\ghash.h
+	<glib/gtypes.h>
+	<glib/glist.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\ghook.h
+	<glib/gmem.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\ghostutils.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\giochannel.h
+	<glib/gconvert.h>
+	<glib/gmain.h>
+	<glib/gstring.h>
+
+1293381427 ing.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gmain.h
+	<glib/gpoll.h>
+	<glib/gslist.h>
+	<glib/gthread.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gpoll.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gslist.h
+	<glib/gmem.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gstring.h
+	<glib/gtypes.h>
+	<glib/gunicode.h>
+	<glib/gutils.h>
+
+1293381427 ls.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gunicode.h
+	<glib/gerror.h>
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gkeyfile.h
+	<glib/gerror.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gmappedfile.h
+	<glib/gerror.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gmarkup.h
+	<stdarg.h>
+	<glib/gerror.h>
+	<glib/gslist.h>
+
+1293381427 st.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gmessages.h
+	<stdarg.h>
+	<glib/gtypes.h>
+	<glib/gmacros.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gnode.h
+	<glib/gmem.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\goption.h
+	<glib/gerror.h>
+	<glib/gquark.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gpattern.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gprimes.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gqsort.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gqueue.h
+	<glib/glist.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\grand.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\grel.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gregex.h
+	<glib/gerror.h>
+	<glib/gstring.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gscanner.h
+	<glib/gdataset.h>
+	<glib/ghash.h>
+
+1293381427 h.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gsequence.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gshell.h
+	<glib/gerror.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gspawn.h
+	<glib/gerror.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gstrfuncs.h
+	<stdarg.h>
+	<glib/gmacros.h>
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gtestutils.h
+	<glib/gmessages.h>
+	<glib/gstring.h>
+	<glib/gerror.h>
+	<glib/gslist.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gthreadpool.h
+	<glib/gthread.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gtimer.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gtree.h
+	<glib/gnode.h>
+
+1293381427 e.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gurifuncs.h
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gvarianttype.h
+	<glib/gmessages.h>
+	<glib/gtypes.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gvariant.h
+	<glib/gvarianttype.h>
+	<glib/gstring.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gwin32.h
+	<glib/gtypes.h>
+
+1228530732 c:\mingw\include\windows.h
+	<winresrc.h>
+	<stdarg.h>
+	<windef.h>
+	<wincon.h>
+	<winbase.h>
+	<wingdi.h>
+	<winuser.h>
+	<winnls.h>
+	<winver.h>
+	<winnetwk.h>
+	<winreg.h>
+	<winsvc.h>
+	<cderr.h>
+	<dde.h>
+	<ddeml.h>
+	<dlgs.h>
+	<imm.h>
+	<lzexpand.h>
+	<mmsystem.h>
+	<nb30.h>
+	<rpc.h>
+	<shellapi.h>
+	<winperf.h>
+	<commdlg.h>
+	<winspool.h>
+	<winsock2.h>
+	<winsock.h>
+	<ole2.h>
+
+1228530732 c:\mingw\include\winresrc.h
+	<winuser.h>
+	<winnt.h>
+	<winver.h>
+	<dde.h>
+	<dlgs.h>
+	<commctrl.h>
+
+1293381427 h>
+
+1228530734 c:\mingw\include\winuser.h
+
+1228530732 c:\mingw\include\winnt.h
+	<winerror.h>
+	<string.h>
+	<basetsd.h>
+	<pshpack4.h>
+	<poppack.h>
+
+1228530732 >
+
+1228530732 c:\mingw\include\winerror.h
+
+1228530712 c:\mingw\include\basetsd.h
+
+1228530724 c:\mingw\include\pshpack4.h
+
+1228530724 c:\mingw\include\poppack.h
+
+1228530734 c:\mingw\include\winver.h
+
+1228530714 c:\mingw\include\dde.h
+
+1228530714 c:\mingw\include\dlgs.h
+
+1228530714 c:\mingw\include\commctrl.h
+	<prsht.h>
+
+1228530724 c:\mingw\include\prsht.h
+
+1228530732 c:\mingw\include\windef.h
+	<winnt.h>
+
+1228530732 c:\mingw\include\wincon.h
+
+1228530730 c:\mingw\include\winbase.h
+
+1228530732 c:\mingw\include\wingdi.h
+
+1228530732 c:\mingw\include\winnls.h
+
+1228530732 c:\mingw\include\winnetwk.h
+
+1228530732 c:\mingw\include\winreg.h
+
+1228530734 c:\mingw\include\winsvc.h
+
+1228530712 c:\mingw\include\cderr.h
+
+1228530714 c:\mingw\include\ddeml.h
+
+1228530716 c:\mingw\include\imm.h
+
+1228530720 c:\mingw\include\lzexpand.h
+
+1228530722 c:\mingw\include\mmsystem.h
+
+1228530722 c:\mingw\include\nb30.h
+
+1228530726 c:\mingw\include\rpc.h
+	<windows.h>
+	<rpcdce.h>
+	<rpcnsi.h>
+	<rpcnterr.h>
+	<winerror.h>
+	<excpt.h>
+
+1228530726 c:\mingw\include\rpcdce.h
+	<basetyps.h>
+	<rpcdcep.h>
+
+1228530712 c:\mingw\include\basetyps.h
+
+1228530728 c:\mingw\include\rpcdcep.h
+
+1228530728 c:\mingw\include\rpcnsi.h
+
+1228530728 c:\mingw\include\rpcnterr.h
+
+1250305076 c:\mingw\include\excpt.h
+	<_mingw.h>
+	<windef.h>
+
+1228530728 c:\mingw\include\shellapi.h
+	<pshpack2.h>
+	<poppack.h>
+
+1228530724 c:\mingw\include\pshpack2.h
+
+1228530732 c:\mingw\include\winperf.h
+
+1228530714 c:\mingw\include\commdlg.h
+	<unknwn.h>
+	<prsht.h>
+
+1228530730 c:\mingw\include\unknwn.h
+	<windows.h>
+	<objfwd.h>
+	<wtypes.h>
+
+1228530724 c:\mingw\include\objfwd.h
+	<basetyps.h>
+
+1228530734 c:\mingw\include\wtypes.h
+	<rpc.h>
+	<rpcndr.h>
+
+1228530728 c:\mingw\include\rpcndr.h
+	<rpcnsip.h>
+	<objfwd.h>
+
+1228530728 c:\mingw\include\rpcnsip.h
+
+1228530734 c:\mingw\include\winspool.h
+
+1228530734 c:\mingw\include\winsock2.h
+	<windows.h>
+
+1228530732 c:\mingw\include\winsock.h
+	<windows.h>
+	<mswsock.h>
+
+1228530722 c:\mingw\include\mswsock.h
+
+1228530724 c:\mingw\include\ole2.h
+	<winerror.h>
+	<objbase.h>
+	<olectlid.h>
+	<oleauto.h>
+	<oleidl.h>
+
+1228530724 c:\mingw\include\objbase.h
+	<rpc.h>
+	<rpcndr.h>
+	<stdlib.h>
+	<basetyps.h>
+	<wtypes.h>
+	<unknwn.h>
+	<objidl.h>
+	<cguid.h>
+
+1228530724 c:\mingw\include\objidl.h
+	<objfwd.h>
+
+1228530712 c:\mingw\include\cguid.h
+
+1228530724 c:\mingw\include\olectlid.h
+
+1228530724 c:\mingw\include\oleauto.h
+	<oaidl.h>
+
+1228530722 c:\mingw\include\oaidl.h
+	<windows.h>
+	<ole2.h>
+
+1228530724 c:\mingw\include\oleidl.h
+	<objfwd.h>
+
+1299757380 x:\utils_g\include\scol_plugin_win.h
+	<windows.h>
+	<stdio.h>
+	<stdlib.h>
+
+1299757369 x:\utils_g\include\scol_plugin_lin.h
+	<stdio.h>
+	<stdlib.h>
+
+1299757512 x:\utils_g\include\macros.h
+
+1293381427 c:\mingw\include\glib-2.0\glib\gstdio.h
+	<glib/gprintf.h>
+	<sys/stat.h>
+
+1293381427 c:\mingw\include\glib-2.0\glib\gprintf.h
+	<glib.h>
+	<stdio.h>
+	<stdarg.h>
+
+1250305082 c:\mingw\include\sys\stat.h
+	<_mingw.h>
+	<stddef.h>
+	<sys/types.h>
+
+1299761247 source:x:\utils_g\src\scol_glib_keyfile.c
+	"../include/scol_glib_keyfile.h"
+
+1299710064 e/scol_glib_keyfile.h"
+
+1299761255 x:\utils_g\include\scol_glib_keyfile.h
+	"main.h"
+	<glib/gstdio.h>
+
+1299756261 source:/home/iri/Works/xp/utils_g/src/scol_glib_keyfile.c
+	"../include/scol_glib_keyfile.h"
+
+1299755949 /home/iri/Works/xp/utils_g/include/scol_glib_keyfile.h
+	"main.h"
+	<glib/gstdio.h>
+
+1298417439 /home/iri/Works/xp/utils_g/include/main.h
+	<stdio.h>
+	<stdlib.h>
+	<string.h>
+	<math.h>
+	<libgen.h>
+	<glib.h>
+	<windows.h>
+	"scol_plugin_win.h"
+	"scol_plugin_lin.h"
+	"macros.h"
+
+1273400331 /usr/include/glib-2.0/glib.h
+	<glib/galloca.h>
+	<glib/garray.h>
+	<glib/gasyncqueue.h>
+	<glib/gatomic.h>
+	<glib/gbacktrace.h>
+	<glib/gbase64.h>
+	<glib/gbitlock.h>
+	<glib/gbookmarkfile.h>
+	<glib/gcache.h>
+	<glib/gchecksum.h>
+	<glib/gcompletion.h>
+	<glib/gconvert.h>
+	<glib/gdataset.h>
+	<glib/gdate.h>
+	<glib/gdir.h>
+	<glib/gerror.h>
+	<glib/gfileutils.h>
+	<glib/ghash.h>
+	<glib/ghook.h>
+	<glib/ghostutils.h>
+	<glib/giochannel.h>
+	<glib/gkeyfile.h>
+	<glib/glist.h>
+	<glib/gmacros.h>
+	<glib/gmain.h>
+	<glib/gmappedfile.h>
+	<glib/gmarkup.h>
+	<glib/gmem.h>
+	<glib/gmessages.h>
+	<glib/gnode.h>
+	<glib/goption.h>
+	<glib/gpattern.h>
+	<glib/gpoll.h>
+	<glib/gprimes.h>
+	<glib/gqsort.h>
+	<glib/gquark.h>
+	<glib/gqueue.h>
+	<glib/grand.h>
+	<glib/grel.h>
+	<glib/gregex.h>
+	<glib/gscanner.h>
+	<glib/gsequence.h>
+	<glib/gshell.h>
+	<glib/gslice.h>
+	<glib/gslist.h>
+	<glib/gspawn.h>
+	<glib/gstrfuncs.h>
+	<glib/gstring.h>
+	<glib/gtestutils.h>
+	<glib/gthread.h>
+	<glib/gthreadpool.h>
+	<glib/gtimer.h>
+	<glib/gtree.h>
+	<glib/gtypes.h>
+	<glib/gunicode.h>
+	<glib/gurifuncs.h>
+	<glib/gutils.h>
+	<glib/gvarianttype.h>
+	<glib/gvariant.h>
+	<glib/gwin32.h>
+
+1273400331 /usr/include/glib-2.0/glib/galloca.h
+	<glib/gtypes.h>
+	<alloca.h>
+	<malloc.h>
+
+1273400331 /usr/include/glib-2.0/glib/gtypes.h
+	<glibconfig.h>
+	<glib/gmacros.h>
+
+1273400330 /usr/lib/glib-2.0/include/glibconfig.h
+	<glib/gmacros.h>
+	<limits.h>
+	<float.h>
+
+1273400331 /usr/include/glib-2.0/glib/gmacros.h
+	<stddef.h>
+
+1273400331 /usr/include/glib-2.0/glib/garray.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gasyncqueue.h
+	<glib/gthread.h>
+
+1273400331 /usr/include/glib-2.0/glib/gthread.h
+	<glib/gerror.h>
+	<glib/gtypes.h>
+	<glib/gutils.h>
+	<glib/gatomic.h>
+
+1273400331 /usr/include/glib-2.0/glib/gerror.h
+	<stdarg.h>
+	<glib/gquark.h>
+
+1273400331 /usr/include/glib-2.0/glib/gquark.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gutils.h
+	<glib/gtypes.h>
+	<stdarg.h>
+
+1273400331 /usr/include/glib-2.0/glib/gatomic.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gbacktrace.h
+	<glib/gtypes.h>
+	<signal.h>
+
+1273400331 /usr/include/glib-2.0/glib/gbase64.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gbitlock.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gbookmarkfile.h
+	<glib/gerror.h>
+	<time.h>
+
+1273400331 /usr/include/glib-2.0/glib/gcache.h
+	<glib/glist.h>
+
+1273400331 /usr/include/glib-2.0/glib/glist.h
+	<glib/gmem.h>
+
+1273400331 /usr/include/glib-2.0/glib/gmem.h
+	<glib/gslice.h>
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gslice.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gchecksum.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gcompletion.h
+	<glib/glist.h>
+
+1273400331 /usr/include/glib-2.0/glib/gconvert.h
+	<glib/gerror.h>
+
+1273400331 /usr/include/glib-2.0/glib/gdataset.h
+	<glib/gquark.h>
+
+1273400331 /usr/include/glib-2.0/glib/gdate.h
+	<time.h>
+	<glib/gtypes.h>
+	<glib/gquark.h>
+
+1273400331 /usr/include/glib-2.0/glib/gdir.h
+	<glib/gerror.h>
+
+1273400331 /usr/include/glib-2.0/glib/gfileutils.h
+	<glib/gerror.h>
+
+1273400331 /usr/include/glib-2.0/glib/ghash.h
+	<glib/gtypes.h>
+	<glib/glist.h>
+
+1273400331 /usr/include/glib-2.0/glib/ghook.h
+	<glib/gmem.h>
+
+1273400331 /usr/include/glib-2.0/glib/ghostutils.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/giochannel.h
+	<glib/gconvert.h>
+	<glib/gmain.h>
+	<glib/gstring.h>
+
+1273400331 /usr/include/glib-2.0/glib/gmain.h
+	<glib/gpoll.h>
+	<glib/gslist.h>
+	<glib/gthread.h>
+
+1273400331 /usr/include/glib-2.0/glib/gpoll.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gslist.h
+	<glib/gmem.h>
+
+1273400331 /usr/include/glib-2.0/glib/gstring.h
+	<glib/gtypes.h>
+	<glib/gunicode.h>
+	<glib/gutils.h>
+
+1273400331 /usr/include/glib-2.0/glib/gunicode.h
+	<glib/gerror.h>
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gkeyfile.h
+	<glib/gerror.h>
+
+1273400331 /usr/include/glib-2.0/glib/gmappedfile.h
+	<glib/gerror.h>
+
+1273400331 /usr/include/glib-2.0/glib/gmarkup.h
+	<stdarg.h>
+	<glib/gerror.h>
+	<glib/gslist.h>
+
+1273400331 /usr/include/glib-2.0/glib/gmessages.h
+	<stdarg.h>
+	<glib/gtypes.h>
+	<glib/gmacros.h>
+
+1273400331 /usr/include/glib-2.0/glib/gnode.h
+	<glib/gmem.h>
+
+1273400331 /usr/include/glib-2.0/glib/goption.h
+	<glib/gerror.h>
+	<glib/gquark.h>
+
+1273400331 /usr/include/glib-2.0/glib/gpattern.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gprimes.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gqsort.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gqueue.h
+	<glib/glist.h>
+
+1273400331 /usr/include/glib-2.0/glib/grand.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/grel.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gregex.h
+	<glib/gerror.h>
+	<glib/gstring.h>
+
+1273400331 /usr/include/glib-2.0/glib/gscanner.h
+	<glib/gdataset.h>
+	<glib/ghash.h>
+
+1273400331 /usr/include/glib-2.0/glib/gsequence.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gshell.h
+	<glib/gerror.h>
+
+1273400331 /usr/include/glib-2.0/glib/gspawn.h
+	<glib/gerror.h>
+
+1273400331 /usr/include/glib-2.0/glib/gstrfuncs.h
+	<stdarg.h>
+	<glib/gmacros.h>
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gtestutils.h
+	<glib/gmessages.h>
+	<glib/gstring.h>
+	<glib/gtypes.h>
+	<glib/gerror.h>
+	<glib/gslist.h>
+
+1273400331 /usr/include/glib-2.0/glib/gthreadpool.h
+	<glib/gthread.h>
+
+1273400331 /usr/include/glib-2.0/glib/gtimer.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gtree.h
+	<glib/gnode.h>
+
+1273400331 /usr/include/glib-2.0/glib/gurifuncs.h
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gvarianttype.h
+	<glib/gmessages.h>
+	<glib/gtypes.h>
+
+1273400331 /usr/include/glib-2.0/glib/gvariant.h
+	<glib/gvarianttype.h>
+	<glib/gstring.h>
+
+1273400331 /usr/include/glib-2.0/glib/gwin32.h
+	<glib/gtypes.h>
+
+1297894138 /home/iri/Works/xp/utils_g/include/scol_plugin_win.h
+	<windows.h>
+	<stdio.h>
+	<stdlib.h>
+
+1296481042 /home/iri/Works/xp/utils_g/include/scol_plugin_lin.h
+	<stdio.h>
+	<stdlib.h>
+
+1298486475 /home/iri/Works/xp/utils_g/include/macros.h
+
+1273400331 /usr/include/glib-2.0/glib/gstdio.h
+	<glib/gprintf.h>
+	<sys/stat.h>
+
+1273400331 /usr/include/glib-2.0/glib/gprintf.h
+	<glib.h>
+	<stdio.h>
+	<stdarg.h>
+
Index: pcre.depend
===================================================================
--- pcre.depend	(revision 2578)
+++ pcre.depend	(revision 2579)
@@ -294,10 +294,10 @@
 1293381427 c:\mingw\include\glib-2.0\glib\gwin32.h
 	<glib/gtypes.h>
 
-1298498356 source:x:\utils_g\src\scol_glib_pregex.c
+1298579809 source:x:\utils_g\src\scol_glib_pregex.c
 	"../include/scol_glib_pregex.h"
 
-1298498380 x:\utils_g\include\scol_glib_pregex.h
+1298579825 x:\utils_g\include\scol_glib_pregex.h
 	<stdio.h>
 	<stdlib.h>
 	<string.h>
Index: src/scol_glib_keyfile.c
===================================================================
--- src/scol_glib_keyfile.c	(nonexistent)
+++ src/scol_glib_keyfile.c	(revision 2579)
@@ -0,0 +1,1571 @@
+/*! \file scol_glib_keyfile.c
+*	\brief all functions of this API
+*   \author Stephane Bisaro
+*/
+/*
+This source file is part of Scol
+For the latest info, see http://www.scolring.org
+
+Copyright (c) 2010 Stephane Bisaro, aka Iri <iri@irizone.net>
+
+This program is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the Free Software
+Foundation; either version 2 of the License, or (at your option) any later
+version.
+
+This program is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public License along with
+this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+Place - Suite 330, Boston, MA 02111-1307, USA, or go to
+http://www.gnu.org/copyleft/lesser.txt
+
+For others informations, please contact us from http://www.scolring.org/
+*/
+
+#include "../include/scol_glib_keyfile.h"
+
+#if ((defined _WIN32) || (defined __WIN32__))
+cbmachine ww;
+#endif
+mmachine  mm;
+
+
+/**
+ * \brief GKF_VALUE_RAW : I : flag used to load a key file. The raw value associated with key under group.
+ * The value can be escaped string
+ */
+int GKF_VALUE_RAW (mmachine m) { return MMpush (m, ITOM (1)); }
+/**
+ * \brief GKF_VALUE_STRING : I : flag used to load a key file. The string value associated with key under group.
+ * Unlike GKF_VALUE_RAW, any escaped sequence are unescaped
+ */
+int GKF_VALUE_STRING (mmachine m) { return MMpush (m, ITOM (2)); }
+/**
+ * \brief GKF_VALUE_INTEGER : Not implemented yet
+ */
+int GKF_VALUE_INTEGER (mmachine m) { return MMpush (m, ITOM (3)); }
+/**
+ * \brief GKF_VALUE_INTEGER64 : Not implemented yet
+ */
+int GKF_VALUE_INTEGER64 (mmachine m) { return MMpush (m, ITOM (4)); }
+/**
+ * \brief GKF_VALUE_UINTEGER64 : Not implemented yet
+ */
+int GKF_VALUE_UINTEGER64 (mmachine m) { return MMpush (m, ITOM (5)); }
+/**
+ * \brief GKF_VALUE_DOUBLE : Not implemented yet
+ */
+int GKF_VALUE_DOUBLE (mmachine m) { return MMpush (m, ITOM (6)); }
+/**
+ * \brief GKF_VALUE_BOOLEAN : Not implemented yet
+ */
+int GKF_VALUE_BOOLEAN (mmachine m) { return MMpush (m, ITOM (7)); }
+
+
+/**
+ * \brief _gkeyFileReadP : read a key file
+ * fun [P S] [[S [[S S] r1]] r1]
+ *
+ * \param P : any file (read reference only)
+ * \param S : the list seperator, or nil (default ";")
+ * \return [[S [[S S] r1]] r1] : the list of datas : group names and for each group name, a list of tuple [key value]
+ */
+int SCOL_gkeyFileReadP (mmachine m)
+{
+    int mfile, msep;
+    gboolean b;
+    GKeyFile *ini;
+    GError *err = NULL;
+
+    msep = MTOP (MMpull (m));
+    mfile = MMpull (m);
+    if (mfile == NIL)
+    {
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = g_key_file_new ();
+    if (msep != NIL)
+        g_key_file_set_list_separator (ini, (MMstart (m, msep))[0]);
+    b = g_key_file_load_from_file (ini, MMstartstr (m, MTOP (mfile)), G_KEY_FILE_NONE, &err);
+    if (!b)
+    {
+        MMechostr (0, "SCOL_gkeyFileReadP load error : %d .:. %s\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+        return 0;
+    }
+    g_key_file_free (ini);
+    return scol_g_key_file_read (ini, m);
+}
+
+
+
+
+
+
+
+
+/* ========================================================================= */
+
+
+/** \private
+ * internal function : get groups names
+ */
+int scol_g_key_file_get_groups (mmachine m, int flag)
+{
+    int mini;
+    int i = 0;
+    gsize len = 0;
+    GKeyFile *ini;
+    gchar **groups;
+
+    mini = MMpull (m);
+    if (mini == NIL)
+    {
+        MMechostr (0, "scol_g_key_file_get_groups error : object is nil\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    groups = g_key_file_get_groups (ini, &len);
+    if (flag)
+        MMpush (m, ITOM ((int) len));   /* I */
+    else
+    {
+        for (i = 0; i < (int) len; i++)
+            Mpushstrbloc (m, groups[i]);
+        MMpush (m, NIL);
+        for (i = 0; i < (int) len; i++)
+        {
+            MMpush (m, ITOM (2));
+            MBdeftab (m);
+        }                               /* [S r1] */
+    }
+    g_strfreev (groups);
+    return 0;
+}
+/** \private
+ * internal function : return a list of the entire content ( [[S [[S S] r1]] r1] )
+ */
+int scol_g_key_file_read (GKeyFile *ini, mmachine m)
+{
+    int i, j;
+    gsize ngroups, nkeys;
+    gchar **groups;
+
+    groups = g_key_file_get_groups (ini, &ngroups);
+    for (i = 0; i < (int) ngroups; i++)
+    {
+        gchar **keys;
+
+        Mpushstrbloc (m, groups[i]);    /* S */
+
+        keys = g_key_file_get_keys (ini, groups[i], &nkeys, NULL);
+        for (j = 0; j < (int) nkeys; j++)
+        {
+            gchar *value;
+
+            value = g_key_file_get_value (ini, groups[i], keys[j], NULL);
+            Mpushstrbloc (m, keys[j]);
+            Mpushstrbloc (m, value);
+            MMpush (m, ITOM (2));
+            MBdeftab (m);               /* [S S] */
+            g_free (value);
+        }
+        g_strfreev (keys);
+        MMpush (m, NIL);
+        for (j = 0; j < (int) nkeys; j++)
+        {
+            MMpush (m, ITOM (2));
+            MBdeftab (m);
+        }                               /* [[S S] r1] */
+        MMpush (m, ITOM (2));
+        MBdeftab (m);                   /* [S [[S S] r1]] */
+    }
+    g_strfreev (groups);
+    MMpush (m, NIL);
+    for (i = 0; i < (int) ngroups; i++)
+    {
+        MMpush (m, ITOM (2));
+        MBdeftab (m);
+    }                                   /* [[S [[S S] r1]] r1] */
+    return 0;
+}
+
+/** \private
+ * internal function : load a file or data
+ */
+int scol_g_key_file_load (mmachine m, int typ)
+{
+    int mchannel, mfile, msep, mflag;
+    int initab;
+    gboolean b;
+    GKeyFileFlags flag = G_KEY_FILE_NONE;
+    GKeyFile *ini;
+    GError *err = NULL;
+
+    mflag = MTOI (MMpull (m));
+    msep = MTOP (MMpull (m));
+    mfile = MMpull (m);
+    mchannel = MMget (m, 0);
+
+    if (mchannel == NIL)
+    {
+        MMechostr (0, "scol_g_key_file_load error : channel is nil\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+    if (mfile == NIL)
+    {
+        MMechostr (0, "scol_g_key_file_load error : file is nil\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = g_key_file_new ();
+    if (msep != NIL)
+        g_key_file_set_list_separator (ini, (MMstart (m, msep))[0]);
+
+    if (mflag == 1)
+        flag = G_KEY_FILE_KEEP_COMMENTS;
+    else if (mflag == 2)
+        flag = G_KEY_FILE_KEEP_TRANSLATIONS;
+    else if (mflag == 3)
+        flag = G_KEY_FILE_KEEP_TRANSLATIONS|G_KEY_FILE_KEEP_COMMENTS;
+
+    if (typ)
+        b = g_key_file_load_from_data (ini, MMstartstr (m, MTOP (mfile)), MMsizestr (m, MTOP (mfile)), flag, &err);
+    else
+        b = g_key_file_load_from_file (ini, MMstartstr (m, MTOP (mfile)), flag, &err);
+    if ((!b) || (err != NULL))
+    {
+        MMechostr (0, "scol_g_key_file_load error : loading is failed -> %s\n", err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    initab = MMmalloc (m, sizeof (ini) + 1, TYPETAB);
+    if (initab == NIL)
+    {
+        MMechostr (0, "scol_g_key_file_load error : not enough memory\n");
+        MMpull (m);
+        MMpush (m, NIL);
+        g_key_file_free (ini);
+        return 0;
+    }
+    MMstore (m, initab, OBJGKEYFILE_HANDLE, (int) ini);
+    MMpush (m, PTOM (initab));
+    OBJcreate (m, ObjKeyFile, (int) ini, -1, -1);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileLoadP : Loads a key file from any valid file
+ *
+ * fun [Chn P S I] ObjKeyFile
+ *
+ * \param Chn : the channel
+ * \param P : any read referenced file
+ * \param S : the list separator or nil (default ";"). One character only (if more, they are ignored)
+ * \param I : flag :
+ *      0 -> No flags, default behaviour
+ *      1 -> Use this flag if you plan to write the (possibly modified) contents of the key file back to a file;
+ *      otherwise all comments will be lost when the key file is written back.
+ *      2 -> Use this flag if you plan to write the (possibly modified) contents of the key file back to a file;
+ *      otherwise only the translations for the current language will be written back.
+ *      3 -> 1 and 2
+ * \return ObjKeyFile : the new object, or nil if error
+ *
+ * Importante note : if you want get/set any localized key, be sure set the flag to 2 (or 3) !
+ */
+int SCOL_gkeyFileLoadP (mmachine m)
+{
+    return scol_g_key_file_load (m, 0);
+}
+
+/**
+ * \brief _gkeyFileLoadS : Loads a key file from any valid data
+ *
+ * fun [Chn P S I] ObjKeyFile
+ *
+ * \param Chn : the channel
+ * \param S : any valid content
+ * \param S : the list separator or nil (default ";"). One character only (if more, they are ignored)
+ * \param I : flag :
+ *      0 -> No flags, default behaviour
+ *      1 -> Use this flag if you plan to write the (possibly modified) contents of the key file back to a file;
+ *      otherwise all comments will be lost when the key file is written back.
+ *      2 -> Use this flag if you plan to write the (possibly modified) contents of the key file back to a file;
+ *      otherwise only the translations for the current language will be written back.
+ *      3 -> 1 and 2
+ * \return ObjKeyFile : the new object, or nil if error
+ */
+int SCOL_gkeyFileLoadS (mmachine m)
+{
+    return scol_g_key_file_load (m, 1);
+}
+
+
+/**
+ * \brief _gkeyFileSave : save a keyfile to a filename
+ *
+ * fun [ObjKeyFile W] I
+ *
+ * \param ObjKeyFile : a valid object
+ * \param W : a Scol write referenced filename
+ * \return I : 0 if success or nil if error (see log message)
+ */
+int SCOL_gkeyFileSave (mmachine m)
+{
+    int mini, mwfile;
+    gboolean b;
+    GKeyFile *ini;
+    gchar *content, *wfile;
+    gsize len = 0;
+    GError *err = NULL;
+
+    mwfile = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mwfile == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileSave error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    wfile = MMstartstr (m, MTOP (mwfile));
+    content = g_key_file_to_data (ini, &len, &err);
+    if ((content == NULL) || (err != NULL))
+    {
+        MMechostr (0, "SCOL_gkeyFileSave error : %d ->  %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+        return 0;
+    }
+    b = g_file_set_contents (wfile, content, len, &err);
+    if ((!b) || (err != NULL))
+    {
+        MMechostr (0, "SCOL_gkeyFileSave error : %d ->  %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+        return 0;
+    }
+    g_free (content);
+    MMpush (m, ITOM (0));
+    return 0;
+}
+
+/**
+ *\brief _gkeyFileDestroy : Destroys an object
+ *
+ * \param ObjKeyFile
+ * \return I : O or nil if error
+ */
+int SCOL_gkeyFileDestroy (mmachine m)
+{
+    int mini;
+    GKeyFile *ini;
+
+    mini = MMpull (m);
+    if (mini == NIL)
+    {
+        MMechostr (0, "SCOL_gkeyFileDestroy error : object is nil\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    g_key_file_free (ini);
+    OBJdelTM (m, ObjKeyFile, mini);
+    MMpush (m, 0);
+
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileGetContent : Returns the content of key file
+ *
+ * fun [ObjKeyFile] [S I]
+ *
+ * \param ObjKeyFile : any valid object
+ * \return [S I] : a tuple : the content and its length or nil if error
+ */
+int SCOL_gkeyFileGetContent (mmachine m)
+{
+    int mini;
+    gchar *content;
+    gsize len = 0;
+    GKeyFile *ini;
+
+    mini = MMpull (m);
+    if (mini == NIL)
+    {
+        MMechostr (0, "SCOL_gkeyFileGetContent error : object is nil\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    content = g_key_file_to_data (ini, &len, NULL);
+    Mpushstrbloc (m, content);
+    MMpush (m, ITOM ((int) len));
+    MMpush (m, ITOM (2));
+    MBdeftab (m);
+    g_free (content);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileGetDatas : Return a list of the content
+ *
+ * fun [ObjKeyFile] [[S [[S S] r1]] r1]
+ *
+ * \param ObjKeyFile : an object already created
+ * \return [[S [[S S] r1]] r1] : a list of group names and for each group name, a list of tuple [key value] or nil if error
+ */
+int SCOL_gkeyFileGetDatas (mmachine m)
+{
+    int mini;
+    GKeyFile *ini;
+
+    mini = MMpull (m);
+    if (mini == NIL)
+    {
+        MMechostr (0, "SCOL_gkeyFileGetDatas error : object is nil\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    return scol_g_key_file_read (ini, m);
+}
+
+/**
+ * \brief _gkeyFileGetGroups : Returns a list of all groups
+ *
+ * fun [ObjKeyFile] [S r1]
+ *
+ * \param ObjKeyFile : any object already created
+ * \return [S r1] : this list or nil if error
+ */
+int SCOL_gkeyFileGetGroups (mmachine m)
+{
+    return scol_g_key_file_get_groups (m, 0);
+}
+
+/**
+ * \brief _gkeyFileGetNbGroups : Returns the number of group
+ *
+ * fun [ObjKeyFile] I
+ *
+ * \param ObjKeyFile : any object already created
+ * \return I : this number or nil if error
+ */
+int SCOL_gkeyFileGetNbGroups (mmachine m)
+{
+    return scol_g_key_file_get_groups (m, 1);
+}
+
+/**
+ * \brief _gkeyFileDataExist : Looks whether the key file has the datas
+ *
+ * fun [ObjKeyFile S S] I
+ *
+ * \param ObjKeyFile : any object already created
+ * \param S : a group name or nil
+ * \param S : a key name or nil
+ * \return I : the result (see below) or nil if error
+ *
+ * If the group name and the key name are not nil, this function searches the key into the group.
+ * If found, 1 is returned, else 0
+ * If the group name is nil, this function searches the key into all groups.
+ * The returned value is the number of this key, 0 if not found.
+ * If the key name is nil, this function searches the group into the keyfile.
+ * If found, 1 is returned, else 0.
+ * If the keyfile is nil or if the group and key names are nil, nil is returned.
+ */
+int SCOL_gkeyFileDataExist (mmachine m)
+{
+    int mini, mgroup, mkey;
+    GKeyFile *ini;
+    gboolean b;
+
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if (mini == NIL)
+    {
+        MMechostr (0, "SCOL_gkeyFileDataExist error : object is nil\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    if ((mkey == NIL) && (mgroup == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileDataExist error : group and key are nil\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+
+    if (mkey == NIL)    /* search a group only */
+    {
+        b = g_key_file_has_group (ini, MMstartstr (m, MTOP (mgroup)));
+        MMpush (m, ITOM (b));
+        return 0;
+    }
+
+    if (mgroup == NIL)  /* search a key in all groups */
+    {
+        gchar ** groups;
+        gsize len = 0;
+        int i, r = 0;
+
+        groups = g_key_file_get_groups (ini, &len);
+        for (i = 0; i < len; i++)
+        {
+            if (g_key_file_has_key (ini, groups[i], MMstartstr (m, MTOP (mkey)), NULL))
+                r++;
+        }
+        MMpush (m, ITOM (r));
+        g_strfreev (groups);
+        return 0;
+    }
+
+    /* search a key in a group */
+    b = g_key_file_has_key (ini, MMstartstr (m, MTOP (mgroup)), MMstartstr (m, MTOP (mkey)), NULL);
+    MMpush (m, ITOM (b));
+    return 0;
+}
+
+/**
+ * \brief _keyFileGetValue : Returns the value for any key in any group
+ *
+ * fun [ObjKeyFile S S I] S
+ *
+ * \param ObjKeyFile : any valid object
+ * \param S : any group name
+ * \param S : any key name
+ * \param I : flag : GKF_VALUE_RAW, GKF_VALUE_STRING, GKF_VALUE_INTEGER, GKF_VALUE_INTEGER64, GKF_VALUE_UINTEGER64, GKF_VALUE_DOUBLE, GKF_VALUE_BOOLEAN
+ * GKF_VALUE_RAW and GKF_VALUE_STRING have a difference, others always return a string
+ * \return S : the value or nil if error or not found
+ */
+int SCOL_keyFileGetValue (mmachine m)
+{
+    int mini, mgroup, mkey, mflag;
+    GKeyFile *ini;
+    gchar *value, *group, *key;
+    GError *err = NULL;
+
+    mflag = MTOI (MMpull (m));
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mkey == NIL) || (mgroup == NIL))
+    {
+        MMechostr (0, "SCOL_keyFileGetValue error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    group = MMstartstr (m, MTOP (mgroup));
+    key = MMstartstr (m, MTOP (mkey));
+
+    switch (mflag)
+    {
+        case (2) :
+            value = g_key_file_get_string (ini, group, key, &err);
+            break;
+
+        case (3) :
+        {
+            int v;
+
+            v = g_key_file_get_integer (ini, group, key, &err);
+            value = g_malloc (sizeof (gchar) * 64);
+            snprintf (value, 64, "%d", v);
+            break;
+        }
+#ifndef GLIB_224
+        case (4) :
+        {
+            gint64 v;
+
+            v = g_key_file_get_int64 (ini, group, key, &err);
+            value = g_malloc (sizeof (gchar) * 64);
+            snprintf (value, 64, "%" G_GINT64_MODIFIER "x", v);
+            break;
+        }
+
+        case (5) :
+        {
+            guint64 v;
+
+            v = g_key_file_get_uint64 (ini, group, key, &err);
+            value = g_malloc (sizeof (gchar) * 64);
+            snprintf (value, 64, "%" G_GUINT64_FORMAT "x", v);
+            break;
+        }
+#endif
+        case (6) :
+        {
+            double v;
+
+            v = g_key_file_get_double (ini, group, key, &err);
+            value = g_malloc (sizeof (gchar) * 64);
+            snprintf (value, 64, "%f", v);
+            break;
+        }
+
+        case (7) :
+        {
+            gboolean v;
+
+            v = g_key_file_get_boolean (ini, group, key, &err);
+            value = g_malloc (sizeof (gchar) * 64);
+            snprintf (value, 64, "%d", v);
+            break;
+        }
+
+        default :
+            value = g_key_file_get_value (ini, group, key, &err);
+
+    }
+    if ((value == NULL) || (err != NULL))
+    {
+        MMechostr (0, "SCOL_keyFileGetValue error : %d -> %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+    }
+    else
+    {
+        Mpushstrbloc (m, value);
+        g_free (value);
+    }
+    return 0;
+}
+
+/**
+ * \brief _keyFileGetLocaleValue : Returns the locale value for any key in any group
+ *
+ * fun [ObjKeyFile S S S] S
+ *
+ * \param ObjKeyFile : any valid object
+ * \param S : any group name
+ * \param S : any key name
+ * \param S : any locale identifier or nil
+ * \return S : the value or nil if error or not found
+ *
+ * If locale is nil or not found, the value of the default key (without localization) will be returned
+ * When the ObjKeyFile has been created, if the flag is at 0 or 1, the current locale can be used only.
+ * In this last case, to get a value of an other locale, the flag should have set to 2 or 3.
+ */
+int SCOL_keyFileGetLocaleValue (mmachine m)
+{
+    int mini, mgroup, mkey, mlang;
+    GKeyFile *ini;
+    gchar *value, *group, *key, *lang = NULL;
+    GError *err = NULL;
+
+    mlang = MMpull (m);
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mkey == NIL) || (mgroup == NIL))
+    {
+        MMechostr (0, "SCOL_keyFileGetLocaleValue error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    group = MMstartstr (m, MTOP (mgroup));
+    key = MMstartstr (m, MTOP (mkey));
+    if (mlang != NIL)
+        lang = MMstartstr (m, MTOP (mlang));
+
+    value = g_key_file_get_locale_string (ini, group, key, lang, &err);
+    if ((value == NULL) || (err != NULL))
+    {
+        MMechostr (0, "SCOL_keyFileGetLocaleValue error : %d -> %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+    }
+
+    Mpushstrbloc (m, value);
+    g_free (value);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileGetValueList : Returns the values associated with key under group
+ *
+ * fun [ObjKeyFile S S] [S r1]
+ *
+ * \param ObjKeyFile : any valid object
+ * \param S : any group name
+ * \param S : any key name
+ * \return [S r1] : the value or nil if error or not found
+ */
+int SCOL_gkeyFileGetValueList (mmachine m)
+{
+    int mini, mgroup, mkey;
+    int i;
+    GKeyFile *ini;
+    gchar *group, *key;
+    gchar **list;
+    gsize len = 0;
+    GError *err = NULL;
+
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mkey == NIL) || (mgroup == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileGetValueList error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    group = MMstartstr (m, MTOP (mgroup));
+    key = MMstartstr (m, MTOP (mkey));
+
+    list = g_key_file_get_string_list (ini, group, key, &len, &err);
+    if ((list == NULL) || (err != NULL))
+    {
+        MMechostr (0, "SCOL_gkeyFileGetValueList error : %d -> %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+    }
+
+    for (i = 0; i < (int) len; i++)
+        Mpushstrbloc (m, list[i]);
+    MMpush (m, NIL);
+    for (i = 0; i < (int) len; i++)
+    {
+        MMpush (m, ITOM (2));
+        MBdeftab (m);
+    }
+    g_strfreev (list);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileGetValueLocaleList : Returns the locales values associated with key under group
+ *
+ * fun [ObjKeyFile S S S] [S r1]
+ *
+ * \param ObjKeyFile : any valid object
+ * \param S : any group name
+ * \param S : any key name
+ * \param S : any locale identifier or nil
+ * \return [S r1] : the value or nil if error or not found
+ *
+ * If locale is nil or not found, the values of the default key (without localization) will be returned
+ * When the ObjKeyFile has been created, if the flag is at 0 or 1, the current locale can be used only.
+ * In this last case, to get the values of an other locale, the flag should have set to 2 or 3.
+ */
+int SCOL_gkeyFileGetValueLocaleList (mmachine m)
+{
+    int mini, mgroup, mkey, mlang;
+    int i;
+    GKeyFile *ini;
+    gchar *group, *key, *lang = NULL;
+    gchar **list;
+    gsize len = 0;
+    GError *err = NULL;
+
+    mlang = MMpull (m);
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mkey == NIL) || (mgroup == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileGetValueLocaleList error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    group = MMstartstr (m, MTOP (mgroup));
+    key = MMstartstr (m, MTOP (mkey));
+    if (mlang != NIL)
+        lang = MMstartstr (m, MTOP (mlang));
+
+    list = g_key_file_get_locale_string_list (ini, group, key, lang, &len, &err);
+    if ((list == NULL) || (err != NULL))
+    {
+        MMechostr (0, "SCOL_gkeyFileGetValueLocaleList error : %d -> %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+    }
+
+    for (i = 0; i < (int) len; i++)
+        Mpushstrbloc (m, list[i]);
+    MMpush (m, NIL);
+    for (i = 0; i < (int) len; i++)
+    {
+        MMpush (m, ITOM (2));
+        MBdeftab (m);
+    }
+    g_strfreev (list);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileGetComment : Return a comment
+ *
+ * fun [ObjKeyFile S S] S
+ *
+ * \param ObjKeyFile : an object
+ * \param S : a group name
+ * \param S : a key name
+ * \return S : the comment or nil if error or not found
+ *
+ * Retrieves a comment above key name from group name. If key is NULL then comment will be read from above group name.
+ * If both key name and group name are NULL, then comment will be read from above the first group in the file.
+ */
+int SCOL_gkeyFileGetComment (mmachine m)
+{
+    int mini, mgroup, mkey;
+    GKeyFile *ini;
+    gchar *group = NULL, *key = NULL, *comment;
+    GError *err = NULL;
+
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if (mini == NIL)
+    {
+        MMechostr (0, "SCOL_gkeyFileGetComment error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    if (mgroup != NIL)
+        group = MMstartstr (m, MTOP (mgroup));
+    if (mkey != NIL)
+        key = MMstartstr (m, MTOP (mkey));
+
+    comment = g_key_file_get_comment (ini, group, key, &err);
+    if (err != NULL)
+    {
+        MMechostr (0, "SCOL_gkeyFileGetComment error : %d -> %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+    }
+    Mpushstrbloc (m, comment);
+    g_free (comment);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileSetValue : Associates a new value with key under group.
+ *
+ * Fun [ObjKeyFile S S S I] ObjKeyFile
+ * If key cannot be found then it is created. If group cannot be found then it is created.
+ *
+ * \param ObjKeyFile : a valid object
+ * \param S : a group name
+ * \param S : a key name
+ * \param S : the new value
+ * \param I : a flag : GKF_VALUE_RAW or GKF_VALUE_STRING (others flags aren't implemented yet)
+ * \return ObjKeyFile : the same object or nil if error
+ *
+ * If key or group is nil, the command is ignored but a message is written to the log
+ */
+int SCOL_gkeyFileSetValue (mmachine m)
+{
+    int mini, mgroup, mkey, mvalue, mflag;
+    GKeyFile *ini;
+    gchar *group = NULL, *key = NULL, *value = NULL;
+
+    mflag = MTOI (MMpull (m));
+    mvalue = MMpull (m);
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mvalue == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileSetValue error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    if (mgroup != NIL)
+        group = MMstartstr (m, MTOP (mgroup));
+    if (mkey != NIL)
+        key = MMstartstr (m, MTOP (mkey));
+    if (mvalue != NIL)
+        value =  MMstartstr (m, MTOP (mvalue));
+
+    switch (mflag)
+    {
+        case (2) :
+            g_key_file_set_string (ini, group, key, SCOLUTF8 (value, -1));
+            break;
+
+        default :
+            g_key_file_set_value (ini, group, key, value);
+    }
+    MMpush (m, mini);
+    return 0;
+}
+/**
+ * \brief _gkeyFileSetValue : Associates a new value with key under group.
+ *
+ * Fun [ObjKeyFile S S S I] ObjKeyFile
+ * If key cannot be found then it is created. If group cannot be found then it is created.
+ *
+ * \param ObjKeyFile : a valid object
+ * \param S : a group name
+ * \param S : a key name
+ * \param S : the new value
+ * \param S : a locale identifier
+ * \return ObjKeyFile : the same object or nil if error
+ *
+ * If key or group is nil, the command is ignored but a message is written to the log
+ */
+int SCOL_gkeyFileSetLocaleValue (mmachine m)
+{
+    int mini, mgroup, mkey, mvalue, mlocale;
+    GKeyFile *ini;
+    gchar *group = NULL, *key = NULL, *value = NULL, *locale = NULL;
+
+    mlocale = MMpull (m);
+    mvalue = MMpull (m);
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mvalue == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileSetLocaleValue error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    if (mgroup != NIL)
+        group = MMstartstr (m, MTOP (mgroup));
+    if (mkey != NIL)
+        key = MMstartstr (m, MTOP (mkey));
+    if (mvalue != NIL)
+        value =  SCOLUTF8 (MMstartstr (m, MTOP (mvalue)), -1);
+    if (mlocale != NIL)
+        locale =  MMstartstr (m, MTOP (mlocale));
+
+    g_key_file_set_locale_string (ini, group, key, locale, value);
+    g_free (value);
+    MMpush (m, mini);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileSetValueList : Associates a list of string for key under group.
+ *
+ * fun [ObjKeyFile S S [S r1] ObjKeyFile
+ * If key cannot be found then it is created. If group cannot be found then it is created.
+ *
+ * \param : ObjKeyFile : an object
+ * \param : S : a group
+ * \param : S : a key
+ * \param [S r1] : a list of values
+ * \return ObjKeyFile : the same object or nil if error
+ *
+ * If key or group is nil, the command is ignored but a message is written to the log
+ */
+int SCOL_gkeyFileSetValueList (mmachine m)
+{
+    int mini, mgroup, mkey, mvalues, mtmp;
+    int i = 0, size = 0;
+    GKeyFile *ini;
+    gchar *group = NULL, *key = NULL;
+    gchar ** values = NULL;
+
+    mtmp = MMget (m, 0);    /* blurps */
+    mvalues = MMpull (m);
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mvalues == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileSetValueList error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    if (mgroup != NIL)
+        group = MMstartstr (m, MTOP (mgroup));
+    if (mkey != NIL)
+        key = MMstartstr (m, MTOP (mkey));
+
+    mvalues = MTOP (mvalues);
+    mtmp = MTOP (mtmp);
+
+    while (mtmp != NIL)
+    {
+        size++;
+        mtmp = MMfetch (m, mtmp, 1)>>1;
+    }
+    values = g_new0 (gchar *, size+1);
+    while (mvalues != NIL)
+    {
+        values[i] = SCOLUTF8 (MMstartstr (m, MTOP (MMfetch (m, mvalues, 0))), -1);
+        i++;
+        mvalues = MMfetch (m, mvalues, 1)>>1;
+    }
+
+    g_key_file_set_string_list (ini, group, key, (const gchar** const) values, size);
+    MMpush (m, mini);
+    g_strfreev (values);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileSetValueList : Associates a list of string for key under group.
+ *
+ * fun [ObjKeyFile S S S [S r1] ObjKeyFile
+ * If key cannot be found then it is created. If group cannot be found then it is created.
+ *
+ * \param : ObjKeyFile : an object
+ * \param : S : a group
+ * \param : S : a key
+ * \param : S : a locale identifier
+ * \param [S r1] : a list of values
+ * \return ObjKeyFile : the same object or nil if error
+ *
+ * If key or group is nil, the command is ignored but a message is written to the log
+ */
+int SCOL_gkeyFileSetLocaleValueList (mmachine m)
+{
+    int mini, mgroup, mkey, mlocale, mvalues, mtmp;
+    int i = 0, size = 0;
+    GKeyFile *ini;
+    gchar *group = NULL, *key = NULL, *locale = NULL;
+    gchar ** values = NULL;
+
+    mtmp = MMget (m, 0);    /* blurps */
+    mvalues = MMpull (m);
+    mlocale = MMpull (m);
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mvalues == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileSetLocaleValueList error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    if (mgroup != NIL)
+        group = MMstartstr (m, MTOP (mgroup));
+    if (mkey != NIL)
+        key = MMstartstr (m, MTOP (mkey));
+    if (mlocale != NIL)
+        locale = MMstartstr (m, MTOP (mlocale));
+
+    mvalues = MTOP (mvalues);
+    mtmp = MTOP (mtmp);
+
+    while (mtmp != NIL)
+    {
+        size++;
+        mtmp = MMfetch (m, mtmp, 1)>>1;
+    }
+    values = g_new0 (gchar *, size+1);
+    while (mvalues != NIL)
+    {
+        values[i] = SCOLUTF8 (MMstartstr (m, MTOP (MMfetch (m, mvalues, 0))), -1);
+        i++;
+        mvalues = MMfetch (m, mvalues, 1)>>1;
+    }
+
+    g_key_file_set_locale_string_list (ini, group, key, locale, (const gchar** const) values, size);
+    MMpush (m, mini);
+    g_strfreev (values);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileSetComment : Comments a key, a group or the key file.
+ *
+ * fun [ObjKeyFile S S S] ObjKeyFile
+ *
+ * \param ObjKeyFile : an object already created
+ * \param S : a group
+ * \param S : a key name
+ * \param S : a comment
+ * \return ObjKeyFile : the same object or nil if error
+ *
+ * See _gkeyFileGetComment too
+ */
+int SCOL_gkeyFileSetComment (mmachine m)
+{
+    int mini, mgroup, mkey, mcomment;
+    gboolean b;
+    GKeyFile *ini;
+    gchar *group = NULL, *key = NULL, *comment = NULL;
+    GError *err = NULL;
+
+    mcomment = MMpull (m);
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mcomment == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileSetComment error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    if (mgroup != NIL)
+        group = MMstartstr (m, MTOP (mgroup));
+    if (mkey != NIL)
+        key = MMstartstr (m, MTOP (mkey));
+    comment = SCOLUTF8 (MMstartstr (m, MTOP (mcomment)), -1);
+
+    b = g_key_file_set_comment (ini, group, key, comment, &err);
+    if ((!b) || (err != NULL))
+    {
+        MMechostr (0, "SCOL_gkeyFileSetComment error : %d -> %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+    }
+    MMpush (m, mini);
+    g_free (comment);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileRemGroup : Removes the specified group from the object.
+ *
+ * fun [ObjKeyFile S] ObjKeyFile
+ *
+ * \param ObjKeyFile : an object already created
+ * \param S : a group
+ * \return ObjKeyFile : the same object or nil if error
+ */
+int SCOL_gkeyFileRemGroup (mmachine m)
+{
+    int mini, mgroup;
+    gboolean b;
+    GKeyFile *ini;
+    gchar *group = NULL;
+    GError *err = NULL;
+
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mgroup == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileRemGroup error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    group = MMstartstr (m, MTOP (mgroup));
+    b = g_key_file_remove_group (ini, group, &err);
+    if ((!b) || (err != NULL))
+    {
+        MMechostr (0, "SCOL_gkeyFileRemGroup error : %d -> %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+    }
+    MMpush (m, mini);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileRemKey : Removes the specified key in group from the object.
+ *
+ * fun [ObjKeyFile S S] ObjKeyFile
+ *
+ * \param ObjKeyFile : an object already created
+ * \param S : a group
+ * \param S : a key
+ * \return ObjKeyFile : the same object or nil if error
+ */
+int SCOL_gkeyFileRemKey (mmachine m)
+{
+    int mini, mgroup, mkey;
+    gboolean b;
+    GKeyFile *ini;
+    gchar *group = NULL, *key = NULL;
+    GError *err = NULL;
+
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mgroup == NIL) || (mkey == NIL))
+    {
+        MMechostr (0, "SCOL_gkeyFileRemKey error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    group = MMstartstr (m, MTOP (mgroup));
+    key = MMstartstr (m, MTOP (mkey));
+    b = g_key_file_remove_key (ini, group, key, &err);
+    if ((!b) || (err != NULL))
+    {
+        MMechostr (0, "SCOL_gkeyFileRemKey error : %d -> %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+    }
+    MMpush (m, mini);
+    return 0;
+}
+
+/**
+ * \brief _gkeyFileRemComment : Removes a comment above key from group.
+ *
+ * fun [ObjKeyFile S S] ObjKeyFile
+ * If key is NULL then comment will be removed above group.
+ * If both key and group are NULL, then comment will be removed above the first group in the file.
+ *
+ * \param ObjKeyFile : an object already created
+ * \param S : a group
+ * \param S : a key
+ * \return ObjKeyFile : the same object or nil if error
+ */
+int SCOL_gkeyFileRemComment (mmachine m)
+{
+    int mini, mgroup, mkey;
+    gboolean b;
+    GKeyFile *ini;
+    gchar *group = NULL, *key = NULL;
+    GError *err = NULL;
+
+    mkey = MMpull (m);
+    mgroup = MMpull (m);
+    mini = MMpull (m);
+
+    if ((mini == NIL) || (mgroup == NIL) || (mkey == NIL))
+    {
+        MMechostr (0, "_gkeyFileRemComment error : bad(s) argument(s) !\n");
+        MMpush (m, NIL);
+        return 0;
+    }
+
+    ini = (GKeyFile*) MMfetch (m, MTOP (mini), OBJGKEYFILE_HANDLE);
+    group = MMstartstr (m, MTOP (mgroup));
+    key = MMstartstr (m, MTOP (mkey));
+    b = g_key_file_remove_comment (ini, group, key, &err);
+    if ((!b) || (err != NULL))
+    {
+        MMechostr (0, "_gkeyFileRemComment error : %d -> %s !\n", err->code, err->message);
+        g_error_free (err);
+        MMpush (m, NIL);
+    }
+    MMpush (m, mini);
+    return 0;
+}
+
+
+
+
+
+
+
+
+
+/* API définitions : */
+
+char* gkey_name[GKEYFILE_PKG_NB]=
+{
+    "ObjKeyFile",
+
+    "_gkeyFileReadP",
+
+    "_gkeyFileLoadS",
+    "_gkeyFileLoadP",
+    "_gkeyFileSave",
+    "_gkeyFileDestroy",
+
+    "_gkeyFileGetContent",
+    "_gkeyFileGetDatas",
+    "_gkeyFileGetGroups",
+    "_gkeyFileGetNbGroups",
+    "_gkeyFileDataExist",
+    "_keyFileGetValue",
+    "_keyFileGetLocaleValue",
+    "_gkeyFileGetValueList",
+    "_gkeyFileGetValueLocaleList",
+    "_gkeyFileGetComment",
+
+    "_gkeyFileSetValue",
+    "_gkeyFileSetLocaleValue",
+    "_gkeyFileSetValueList",
+    "_gkeyFileSetLocaleValueList",
+    "_gkeyFileSetComment",
+
+    "_gkeyFileRemGroup",
+    "_gkeyFileRemKey",
+    "_gkeyFileRemComment",
+
+    "GKF_VALUE_RAW",
+    "GKF_VALUE_STRING",
+    "GKF_VALUE_INTEGER",
+    "GKF_VALUE_INTEGER64",
+    "GKF_VALUE_UINTEGER64",
+    "GKF_VALUE_DOUBLE",
+    "GKF_VALUE_BOOLEAN"
+
+};
+
+int (*gkey_fun[GKEYFILE_PKG_NB])(mmachine m)=
+{
+    NULL,
+
+    SCOL_gkeyFileReadP,
+
+    SCOL_gkeyFileLoadS,
+    SCOL_gkeyFileLoadP,
+    SCOL_gkeyFileSave,
+    SCOL_gkeyFileDestroy,
+
+    SCOL_gkeyFileGetContent,
+    SCOL_gkeyFileGetDatas,
+    SCOL_gkeyFileGetGroups,
+    SCOL_gkeyFileGetNbGroups,
+    SCOL_gkeyFileDataExist,
+    SCOL_keyFileGetValue,
+    SCOL_keyFileGetLocaleValue,
+    SCOL_gkeyFileGetValueList,
+    SCOL_gkeyFileGetValueLocaleList,
+    SCOL_gkeyFileGetComment,
+
+    SCOL_gkeyFileSetValue,
+    SCOL_gkeyFileSetLocaleValue,
+    SCOL_gkeyFileSetValueList,
+    SCOL_gkeyFileSetLocaleValueList,
+    SCOL_gkeyFileSetComment,
+
+    SCOL_gkeyFileRemGroup,
+    SCOL_gkeyFileRemKey,
+    SCOL_gkeyFileRemComment,
+
+    GKF_VALUE_RAW,
+    GKF_VALUE_STRING,
+    GKF_VALUE_INTEGER,
+    GKF_VALUE_INTEGER64,
+    GKF_VALUE_UINTEGER64,
+    GKF_VALUE_DOUBLE,
+    GKF_VALUE_BOOLEAN
+};
+
+int gkey_narg[GKEYFILE_PKG_NB]=
+{
+    TYPTYPE,
+
+    2,       /* SCOL_gkeyFileReadP */
+
+    4,       /* SCOL_gkeyFileLoadS */
+    4,       /* SCOL_gkeyFileLoadP */
+    2,       /* SCOL_gkeyFileSave */
+    1,       /* SCOL_gkeyFileDestroy */
+
+    1,       /* SCOL_gkeyFileGetContent */
+    1,       /* SCOL_gkeyFileGetDatas */
+    1,       /* SCOL_gkeyFileGetGroups */
+    1,       /* SCOL_gkeyFileGetNbGroups */
+    3,       /* SCOL_gkeyFileDataExist */
+    4,       /* SCOL_keyFileGetValue */
+    4,       /* SCOL_keyFileGetLocaleValue */
+    3,       /* SCOL_gkeyFileGetValueList */
+    4,       /* SCOL_gkeyFileGetValueLocaleList */
+    3,       /* SCOL_gkeyFileGetComment */
+
+    5,       /* SCOL_gkeyFileSetValue */
+    5,       /* SCOL_gkeyFileSetLocaleValue */
+    4,       /* SCOL_gkeyFileSetValueList */
+    5,       /* SCOL_gkeyFileSetLocaleValueList */
+    4,       /* SCOL_gkeyFileSetComment */
+
+    2,       /* SCOL_gkeyFileRemGroup */
+    3,       /* SCOL_gkeyFileRemKey */
+    3,       /* SCOL_gkeyFileRemComment */
+
+    0,
+    0,
+    0,
+    0,
+    0,
+    0,
+    0
+};
+
+char* gkey_type[GKEYFILE_PKG_NB]=
+{
+    NULL,
+
+    "fun [P S] [[S [[S S] r1]] r1]",        /* SCOL_gkeyFileReadP */
+
+    "fun [Chn S S I] ObjKeyFile",           /* SCOL_gkeyFileLoadS */
+    "fun [Chn P S I] ObjKeyFile",           /* SCOL_gkeyFileLoadP */
+    "fun [ObjKeyFile W] I",                 /* SCOL_gkeyFileSave */
+    "fun [ObjKeyFile] I",                   /* SCOL_gkeyFileDestroy */
+
+    "fun [ObjKeyFile] [S I]",               /* SCOL_gkeyFileGetContent */
+    "fun [ObjKeyFile] [[S [[S S] r1]] r1]", /* SCOL_gkeyFileGetDatas */
+    "fun [ObjKeyFile] [S r1]",              /* SCOL_gkeyFileGetGroups */
+    "fun [ObjKeyFile] I",                   /* SCOL_gkeyFileGetNbGroups */
+    "fun [ObjKeyFile S S] I",               /* SCOL_gkeyFileDataExist */
+    "fun [ObjKeyFile S S I] S",             /* SCOL_keyFileGetValue */
+    "fun [ObjKeyFile S S S] S",             /* SCOL_keyFileGetLocaleValue */
+    "fun [ObjKeyFile S S] [S r1]",          /* SCOL_gkeyFileGetValueList */
+    "fun [ObjKeyFile S S S] [S r1]",        /* SCOL_gkeyFileGetValueLocaleList */
+    "fun [ObjKeyFile S S] S",               /* SCOL_gkeyFileGetComment */
+
+    "fun [ObjKeyFile S S S I] ObjKeyFile",  /* SCOL_gkeyFileSetValue */
+    "fun [ObjKeyFile S S S S] ObjKeyFile",  /* SCOL_gkeyFileSetLocaleValue */
+    "fun [ObjKeyFile S S [S r1]] ObjKeyFile",   /* SCOL_gkeyFileSetValueList */
+    "fun [ObjKeyFile S S S [S r1]] ObjKeyFile", /* SCOL_gkeyFileSetLocaleValueList */
+    "fun [ObjKeyFile S S S] ObjKeyFile",    /* SCOL_gkeyFileSetComment */
+
+    "fun [ObjKeyFile S] ObjKeyFile",        /* SCOL_gkeyFileRemGroup */
+    "fun [ObjKeyFile S S] ObjKeyFile",      /* SCOL_gkeyFileRemKey */
+    "fun [ObjKeyFile S S] ObjKeyFile",      /* SCOL_gkeyFileRemComment */
+
+    "fun [] I",
+    "fun [] I",
+    "fun [] I",
+    "fun [] I",
+    "fun [] I",
+    "fun [] I",
+    "fun [] I"
+};
+
+
+/** \private
+ */
+int ObjKeyFileTypeDestroy (mmachine m, int handsys, int mobj)
+{
+    GKeyFile *o;
+    MMechostr (MSKDEBUG, "ObjKeyFileTypeDestroy: entering\n");
+
+    o = (GKeyFile*) MMfetch (m, MTOP (mobj), OBJGKEYFILE_HANDLE);
+    if (o == (int) NULL)
+    {
+        MMechostr (MSKDEBUG, "ObjKeyFileTypeDestroy : object %p already destroyed\n", (void *) o);
+        return 0;
+    }
+    g_key_file_free (o);
+
+    MMstore (m, MTOP (mobj), OBJGKEYFILE_HANDLE, (int) NULL);
+    MMechostr (MSKDEBUG, "ObjKeyFileTypeDestroy : object %p has been destroyed\n", (void *) o);
+
+    return 0;
+}
+
+/** \private
+ */
+int SCOLinitGlibKeyClass (mmachine m)
+{
+    int k;
+
+    MMechostr (0, "SCOLinitGlibKeyClass : entering\n");
+
+    ObjKeyFile = OBJregister (GKEYFILE_RFL_NB, 1, ObjKeyFileTypeDestroy, "ObjKeyFileType");
+
+    k = PKhardpak (m, "GkeyEngine", GKEYFILE_PKG_NB, gkey_name, gkey_fun, gkey_narg, gkey_type);
+    return k;
+}
+
+
+/**
+ * \private
+ * \brief Free the key file library
+ * Plateforms supported : MS Windows and GNU / Linux
+ */
+int GkeyRelease ()
+{
+    MMechostr (0, "\nG KEY FILE library released !\n");
+    return 0;
+}
+
+/**
+ * \private
+ * \brief Load the key file library
+ * 1- MS Windows
+ * 2- GNU / Linux
+ */
+#if ((defined _WIN32) || (defined __WIN32__))
+
+__declspec (dllexport) int SCOLloadGKEYFILE (mmachine m, cbmachine w)
+{
+    int k = 0;
+    ww = w;
+    mm = m;
+
+    SCOLinitplugin (w);
+    if ((k = SCOLinitGlibKeyClass (m))) return k;
+    MMechostr(MSKDEBUG, "\nG KEY FILE library loaded !\n");
+    return k;
+}
+
+__declspec (dllexport) int SCOLfreeGKEYFILE ()
+{
+    GkeyRelease ();
+    return 0;
+}
+
+
+
+
+
+/* Version GNU / Linux */
+#elif ((defined linux) || (defined __linux))
+
+int SCOLloadGKEYFILE (mmachine m)
+{
+    int k = 0;
+    mm = m;
+
+    if ((k = SCOLinitGlibKeyClass (m))) return k;
+    MMechostr (MSKDEBUG, "\nG KEY FILE library loaded !\n");
+
+    return k;
+}
+
+int SCOLfreeGKEYFILE ()
+{
+    GkeyRelease ();
+    return 0;
+}
+
+#else
+#error no platform supported
+#endif
+
Index: COPYING
===================================================================
--- COPYING	(nonexistent)
+++ COPYING	(revision 2579)
@@ -0,0 +1,482 @@
+GNU LIBRARY GENERAL PUBLIC LICENSE
+                       Version 2, June 1991
+
+ Copyright (C) 1991 Free Software Foundation, Inc.
+ 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+[This is the first released version of the library GPL.  It is
+ numbered 2 because it goes with version 2 of the ordinary GPL.]
+
+                            Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+Licenses are intended to guarantee your freedom to share and change
+free software--to make sure the software is free for all its users.
+
+  This license, the Library General Public License, applies to some
+specially designated Free Software Foundation software, and to any
+other libraries whose authors decide to use it.  You can use it for
+your libraries, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if
+you distribute copies of the library, or if you modify it.
+
+  For example, if you distribute copies of the library, whether gratis
+or for a fee, you must give the recipients all the rights that we gave
+you.  You must make sure that they, too, receive or can get the source
+code.  If you link a program with the library, you must provide
+complete object files to the recipients so that they can relink them
+with the library, after making changes to the library and recompiling
+it.  And you must show them these terms so they know their rights.
+
+  Our method of protecting your rights has two steps: (1) copyright
+the library, and (2) offer you this license which gives you legal
+permission to copy, distribute and/or modify the library.
+
+  Also, for each distributor's protection, we want to make certain
+that everyone understands that there is no warranty for this free
+library.  If the library is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original
+version, so that any problems introduced by others will not reflect on
+the original authors' reputations.
+
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that companies distributing free
+software will individually obtain patent licenses, thus in effect
+transforming the program into proprietary software.  To prevent this,
+we have made it clear that any patent must be licensed for everyone's
+free use or not licensed at all.
+
+  Most GNU software, including some libraries, is covered by the ordinary
+GNU General Public License, which was designed for utility programs.  This
+license, the GNU Library General Public License, applies to certain
+designated libraries.  This license is quite different from the ordinary
+one; be sure to read it in full, and don't assume that anything in it is
+the same as in the ordinary license.
+
+  The reason we have a separate public license for some libraries is that
+they blur the distinction we usually make between modifying or adding to a
+program and simply using it.  Linking a program with a library, without
+changing the library, is in some sense simply using the library, and is
+analogous to running a utility program or application program.  However, in
+a textual and legal sense, the linked executable is a combined work, a
+derivative of the original library, and the ordinary General Public License
+treats it as such.
+
+  Because of this blurred distinction, using the ordinary General
+Public License for libraries did not effectively promote software
+sharing, because most developers did not use the libraries.  We
+concluded that weaker conditions might promote sharing better.
+
+  However, unrestricted linking of non-free programs would deprive the
+users of those programs of all benefit from the free status of the
+libraries themselves.  This Library General Public License is intended to
+permit developers of non-free programs to use free libraries, while
+preserving your freedom as a user of such programs to change the free
+libraries that are incorporated in them.  (We have not seen how to achieve
+this as regards changes in header files, but we have achieved it as regards
+changes in the actual functions of the Library.)  The hope is that this
+will lead to faster development of free libraries.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.  Pay close attention to the difference between a
+"work based on the library" and a "work that uses the library".  The
+former contains code derived from the library, while the latter only
+works together with the library.
+
+  Note that it is possible for a library to be covered by the ordinary
+General Public License rather than by this special one.
+
+                  GNU LIBRARY GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License Agreement applies to any software library which
+contains a notice placed by the copyright holder or other authorized
+party saying it may be distributed under the terms of this Library
+General Public License (also called "this License").  Each licensee is
+addressed as "you".
+
+  A "library" means a collection of software functions and/or data
+prepared so as to be conveniently linked with application programs
+(which use some of those functions and data) to form executables.
+
+  The "Library", below, refers to any such software library or work
+which has been distributed under these terms.  A "work based on the
+Library" means either the Library or any derivative work under
+copyright law: that is to say, a work containing the Library or a
+portion of it, either verbatim or with modifications and/or translated
+straightforwardly into another language.  (Hereinafter, translation is
+included without limitation in the term "modification".)
+
+  "Source code" for a work means the preferred form of the work for
+making modifications to it.  For a library, complete source code means
+all the source code for all modules it contains, plus any associated
+interface definition files, plus the scripts used to control compilation
+and installation of the library.
+
+  Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running a program using the Library is not restricted, and output from
+such a program is covered only if its contents constitute a work based
+on the Library (independent of the use of the Library in a tool for
+writing it).  Whether that is true depends on what the Library does
+and what the program that uses the Library does.
+  
+  1. You may copy and distribute verbatim copies of the Library's
+complete source code as you receive it, in any medium, provided that
+you conspicuously and appropriately publish on each copy an
+appropriate copyright notice and disclaimer of warranty; keep intact
+all the notices that refer to this License and to the absence of any
+warranty; and distribute a copy of this License along with the
+Library.
+
+  You may charge a fee for the physical act of transferring a copy,
+and you may at your option offer warranty protection in exchange for a
+fee.
+
+  2. You may modify your copy or copies of the Library or any portion
+of it, thus forming a work based on the Library, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) The modified work must itself be a software library.
+
+    b) You must cause the files modified to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    c) You must cause the whole of the work to be licensed at no
+    charge to all third parties under the terms of this License.
+
+    d) If a facility in the modified Library refers to a function or a
+    table of data to be supplied by an application program that uses
+    the facility, other than as an argument passed when the facility
+    is invoked, then you must make a good faith effort to ensure that,
+    in the event an application does not supply such function or
+    table, the facility still operates, and performs whatever part of
+    its purpose remains meaningful.
+
+    (For example, a function in a library to compute square roots has
+    a purpose that is entirely well-defined independent of the
+    application.  Therefore, Subsection 2d requires that any
+    application-supplied function or table used by this function must
+    be optional: if the application does not supply it, the square
+    root function must still compute square roots.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Library,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Library, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote
+it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Library.
+
+In addition, mere aggregation of another work not based on the Library
+with the Library (or with a work based on the Library) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may opt to apply the terms of the ordinary GNU General Public
+License instead of this License to a given copy of the Library.  To do
+this, you must alter all the notices that refer to this License, so
+that they refer to the ordinary GNU General Public License, version 2,
+instead of to this License.  (If a newer version than version 2 of the
+ordinary GNU General Public License has appeared, then you can specify
+that version instead if you wish.)  Do not make any other change in
+these notices.
+
+  Once this change is made in a given copy, it is irreversible for
+that copy, so the ordinary GNU General Public License applies to all
+subsequent copies and derivative works made from that copy.
+
+  This option is useful when you wish to copy part of the code of
+the Library into a program that is not a library.
+
+  4. You may copy and distribute the Library (or a portion or
+derivative of it, under Section 2) in object code or executable form
+under the terms of Sections 1 and 2 above provided that you accompany
+it with the complete corresponding machine-readable source code, which
+must be distributed under the terms of Sections 1 and 2 above on a
+medium customarily used for software interchange.
+
+  If distribution of object code is made by offering access to copy
+from a designated place, then offering equivalent access to copy the
+source code from the same place satisfies the requirement to
+distribute the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  5. A program that contains no derivative of any portion of the
+Library, but is designed to work with the Library by being compiled or
+linked with it, is called a "work that uses the Library".  Such a
+work, in isolation, is not a derivative work of the Library, and
+therefore falls outside the scope of this License.
+
+  However, linking a "work that uses the Library" with the Library
+creates an executable that is a derivative of the Library (because it
+contains portions of the Library), rather than a "work that uses the
+library".  The executable is therefore covered by this License.
+Section 6 states terms for distribution of such executables.
+
+  When a "work that uses the Library" uses material from a header file
+that is part of the Library, the object code for the work may be a
+derivative work of the Library even though the source code is not.
+Whether this is true is especially significant if the work can be
+linked without the Library, or if the work is itself a library.  The
+threshold for this to be true is not precisely defined by law.
+
+  If such an object file uses only numerical parameters, data
+structure layouts and accessors, and small macros and small inline
+functions (ten lines or less in length), then the use of the object
+file is unrestricted, regardless of whether it is legally a derivative
+work.  (Executables containing this object code plus portions of the
+Library will still fall under Section 6.)
+
+  Otherwise, if the work is a derivative of the Library, you may
+distribute the object code for the work under the terms of Section 6.
+Any executables containing that work also fall under Section 6,
+whether or not they are linked directly with the Library itself.
+
+  6. As an exception to the Sections above, you may also compile or
+link a "work that uses the Library" with the Library to produce a
+work containing portions of the Library, and distribute that work
+under terms of your choice, provided that the terms permit
+modification of the work for the customer's own use and reverse
+engineering for debugging such modifications.
+
+  You must give prominent notice with each copy of the work that the
+Library is used in it and that the Library and its use are covered by
+this License.  You must supply a copy of this License.  If the work
+during execution displays copyright notices, you must include the
+copyright notice for the Library among them, as well as a reference
+directing the user to the copy of this License.  Also, you must do one
+of these things:
+
+    a) Accompany the work with the complete corresponding
+    machine-readable source code for the Library including whatever
+    changes were used in the work (which must be distributed under
+    Sections 1 and 2 above); and, if the work is an executable linked
+    with the Library, with the complete machine-readable "work that
+    uses the Library", as object code and/or source code, so that the
+    user can modify the Library and then relink to produce a modified
+    executable containing the modified Library.  (It is understood
+    that the user who changes the contents of definitions files in the
+    Library will not necessarily be able to recompile the application
+    to use the modified definitions.)
+
+    b) Accompany the work with a written offer, valid for at
+    least three years, to give the same user the materials
+    specified in Subsection 6a, above, for a charge no more
+    than the cost of performing this distribution.
+
+    c) If distribution of the work is made by offering access to copy
+    from a designated place, offer equivalent access to copy the above
+    specified materials from the same place.
+
+    d) Verify that the user has already received a copy of these
+    materials or that you have already sent this user a copy.
+
+  For an executable, the required form of the "work that uses the
+Library" must include any data and utility programs needed for
+reproducing the executable from it.  However, as a special exception,
+the source code distributed need not include anything that is normally
+distributed (in either source or binary form) with the major
+components (compiler, kernel, and so on) of the operating system on
+which the executable runs, unless that component itself accompanies
+the executable.
+
+  It may happen that this requirement contradicts the license
+restrictions of other proprietary libraries that do not normally
+accompany the operating system.  Such a contradiction means you cannot
+use both them and the Library together in an executable that you
+distribute.
+
+  7. You may place library facilities that are a work based on the
+Library side-by-side in a single library together with other library
+facilities not covered by this License, and distribute such a combined
+library, provided that the separate distribution of the work based on
+the Library and of the other library facilities is otherwise
+permitted, and provided that you do these two things:
+
+    a) Accompany the combined library with a copy of the same work
+    based on the Library, uncombined with any other library
+    facilities.  This must be distributed under the terms of the
+    Sections above.
+
+    b) Give prominent notice with the combined library of the fact
+    that part of it is a work based on the Library, and explaining
+    where to find the accompanying uncombined form of the same work.
+
+  8. You may not copy, modify, sublicense, link with, or distribute
+the Library except as expressly provided under this License.  Any
+attempt otherwise to copy, modify, sublicense, link with, or
+distribute the Library is void, and will automatically terminate your
+rights under this License.  However, parties who have received copies,
+or rights, from you under this License will not have their licenses
+terminated so long as such parties remain in full compliance.
+
+  9. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Library or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Library (or any work based on the
+Library), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Library or works based on it.
+
+  10. Each time you redistribute the Library (or any work based on the
+Library), the recipient automatically receives a license from the
+original licensor to copy, distribute, link with or modify the Library
+subject to these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  11. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Library at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Library by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Library.
+
+If any portion of this section is held invalid or unenforceable under any
+particular circumstance, the balance of the section is intended to apply,
+and the section as a whole is intended to apply in other circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  12. If the distribution and/or use of the Library is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Library under this License may add
+an explicit geographical distribution limitation excluding those countries,
+so that distribution is permitted only in or among countries not thus
+excluded.  In such case, this License incorporates the limitation as if
+written in the body of this License.
+
+  13. The Free Software Foundation may publish revised and/or new
+versions of the Library General Public License from time to time.
+Such new versions will be similar in spirit to the present version,
+but may differ in detail to address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Library
+specifies a version number of this License which applies to it and
+"any later version", you have the option of following the terms and
+conditions either of that version or of any later version published by
+the Free Software Foundation.  If the Library does not specify a
+license version number, you may choose any version ever published by
+the Free Software Foundation.
+
+  14. If you wish to incorporate parts of the Library into other free
+programs whose distribution conditions are incompatible with these,
+write to the author to ask for permission.  For software which is
+copyrighted by the Free Software Foundation, write to the Free
+Software Foundation; we sometimes make exceptions for this.  Our
+decision will be guided by the two goals of preserving the free status
+of all derivatives of our free software and of promoting the sharing
+and reuse of software generally.
+
+                            NO WARRANTY
+
+  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
+WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
+EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
+OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY
+KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
+LIBRARY IS WITH YOU.  SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME
+THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
+WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
+AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU
+FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
+CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
+LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
+RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
+FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
+SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
+DAMAGES.
+
+                     END OF TERMS AND CONDITIONS
+
+           How to Apply These Terms to Your New Libraries
+
+  If you develop a new library, and you want it to be of the greatest
+possible use to the public, we recommend making it free software that
+everyone can redistribute and change.  You can do so by permitting
+redistribution under these terms (or, alternatively, under the terms of the
+ordinary General Public License).
+
+  To apply these terms, attach the following notices to the library.  It is
+safest to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least the
+"copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the library's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Library General Public
+    License as published by the Free Software Foundation; either
+    version 2 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Library General Public License for more details.
+
+    You should have received a copy of the GNU Library General Public
+    License along with this library; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+
+Also add information on how to contact you by electronic and paper mail.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the library, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the
+  library `Frob' (a library for tweaking knobs) written by James Random Hacker.
+
+  <signature of Ty Coon>, 1 April 1990
+  Ty Coon, President of Vice
+
+That's all there is to it!
+

Property changes on: COPYING
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Index: keyfile.cbp
===================================================================
--- keyfile.cbp	(nonexistent)
+++ keyfile.cbp	(revision 2579)
@@ -0,0 +1,81 @@
+<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
+<CodeBlocks_project_file>
+	<FileVersion major="1" minor="6" />
+	<Project>
+		<Option title="keyfile" />
+		<Option pch_mode="2" />
+		<Option compiler="gcc" />
+		<Build>
+			<Target title="Debug">
+				<Option output="bin/Debug/gkeyfile" prefix_auto="1" extension_auto="1" />
+				<Option working_dir="bin/" />
+				<Option object_output="obj/Debug/" />
+				<Option type="3" />
+				<Option compiler="gcc" />
+				<Option createDefFile="1" />
+				<Option createStaticLib="1" />
+				<Compiler>
+					<Add option="-g" />
+				</Compiler>
+			</Target>
+			<Target title="Release">
+				<Option output="bin/gkeyfile" prefix_auto="1" extension_auto="1" />
+				<Option working_dir="bin/" />
+				<Option object_output="obj/Release/" />
+				<Option type="3" />
+				<Option compiler="gcc" />
+				<Option createDefFile="1" />
+				<Option createStaticLib="1" />
+				<Compiler>
+					<Add option="-O2" />
+				</Compiler>
+				<Linker>
+					<Add option="-s" />
+				</Linker>
+			</Target>
+		</Build>
+		<Compiler>
+			<Add option="-Wall" />
+			<Add option="-mms-bitfields" />
+			<Add directory="$(#gtk.include)" />
+			<Add directory="$(#gtk.include)/gtk-2.0" />
+			<Add directory="$(#gtk.include)/cairo" />
+			<Add directory="$(#gtk.include)/gdk" />
+			<Add directory="$(#gtk.include)/glib-2.0" />
+			<Add directory="$(#gtk.lib)/glib-2.0/include" />
+			<Add directory="$(#gtk.include)/pango-1.0" />
+			<Add directory="$(#gtk.lib)/gtk-2.0/include" />
+			<Add directory="$(#gtk.include)/atk-1.0" />
+			<Add directory="/usr/include/glib-2.0" />
+			<Add directory="/usr/lib/glib-2.0/include" />
+		</Compiler>
+		<Linker>
+			<Add library="gobject-2.0" />
+			<Add library="glib-2.0" />
+			<Add directory="$(#gtk.lib)" />
+		</Linker>
+		<Unit filename="include/macros.h" />
+		<Unit filename="include/main.h" />
+		<Unit filename="include/scol_glib_keyfile.h" />
+		<Unit filename="include/scol_plugin_lin.h" />
+		<Unit filename="include/scol_plugin_win.h" />
+		<Unit filename="src/scol_glib_keyfile.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Extensions>
+			<code_completion />
+			<debugger />
+			<DoxyBlocks>
+				<comment_style block="0" line="0" />
+				<doxyfile_project project_number="0.2" />
+				<doxyfile_build />
+				<doxyfile_warnings warnings="0" />
+				<doxyfile_alpha_index alphabetical_index="0" />
+				<doxyfile_output />
+				<doxyfile_dot />
+				<general />
+			</DoxyBlocks>
+			<envvars />
+		</Extensions>
+	</Project>
+</CodeBlocks_project_file>
